This guide assumes you're competent enough to atleast have completed the tutorial at Part 1 and Part 2.

1. Extract and/or decompress the update as .nsp so that you have the .nca's it contains. (hactool -t pfs0 "Diablo II Resurrected[0100726014352800][US][v65536].nsp" --outdir=d2r) If it's nsz then figure out how to decompress that. This guide won't cover that.

2. Use hactool on the largest nca container like this (hactool --titlekey=the_key_in_.tik --exefsdir=./ 06828296169b6f96b0123fa7f586d243.nca), you may need a hex editor to view this titlekey if you don't use tools like nxgameinfo_cli ( https://github.com/garoxas/NX_Game_Info ) on the .nsp

3. hactool -t nso0 main --uncompressed=d2r_uncompressed (take note of the buildid, which for version is v65536 32153D9896AE0C7C723F04EC1CE20999CAF7ED69000000000000000000000000) (the buildid is also obtainable by doing `xxd -c 20 -l 0x14 -s 0x40- -g 20 main` on linux or using a hex editor/viewer from 0x40 for 0x14 length)

4. Import it (the uncompressed nso0) into ghidra, load it into ghidra, analyze it. (for a binary this big, it up to 20 minutes on an AMD 5800x processor) If there is an error, just hit "Ok"

5. Press S to open memory search, search for "55 73 65 72 20 4C 61 73 74 20 4F 6E 6C 69" ("User Last Online")

![alt text](https://github.com/borntohonk/SigPatches/blob/master/img/ghidra-d2r-search-memory.png?raw=true)

6. Right click the string, show references to the address, click the result, that will take you to the function you want.

![alt text](https://github.com/borntohonk/SigPatches/blob/master/img/ghidra-d2r-search-memory-1.png?raw=true)

![alt text](https://github.com/borntohonk/SigPatches/blob/master/img/ghidra-d2r-search-memory-2.png?raw=true)

7. We're patching "MOV W8, WZR" (e8 03 1f 2a) with "NOP" (1f 20 03 d5), that will remove the dumb check that it tries to read.

![alt text](https://github.com/borntohonk/SigPatches/blob/master/img/ghidra-d2r-search-memory-3.png?raw=true)

8. Ghidra will show offset that we want as "1B9970", but it must be corrected to "1B9A70". (it must be corrected due to the nature of the switch decompiler addon we use with ghidra, because it offsets the file region by 0x100 to skip the headers of the files it loads)
( you can also open search by pressing S and inserting this hex string: "d2 .. .. .. f2 .. .. .. f2 .. .. .. cb .. .. .. eb .. .. .. .. .. .. .. 14", to get to the offset. )

![alt text](https://github.com/borntohonk/SigPatches/blob/master/img/ghidra-d2r-offset.png?raw=true)

9. Use the knowledge gained, Offset, size 4, NOP (translates to 1b 9A 70 00 04 1F 20 03 D5) (NOP stands for No Operation, and is an ARM instruction which does nothing. The intent with patching the bytes at the offset with NOP is to make it do exactly nothing, which in this case is the desired outcome.)

10. Save "50 41 54 43 48 1B 9A 70 00 04 1F 20 03 D5 45 4F 46" as 32153D9896AE0C7C723F04EC1CE20999CAF7ED69.ips (patch version 131072/ v2, is the exact same offset and patch, before you waste time trying to check. buildid for that is 7E78CC35BAF51EA2907C6C976847207F34F91909, 196608/ v3 and 262144/ v4 share the buildid of 6EBDA61382BBFA70CD032637B10E519EA0005084, aswell as the same patch.)
If you've already forgotten what the buildid is that you need, you should have obtained that at step 3. of this guide.

(You can look at the table below to get a more visual concept of how this patch is structured.)

| PATCH magic | Offset | Size | Patch| EOF magic |
| :---: | :---: | :---: | :---: | :---: |
| 50 41 54 43 48 | 1B 9A 70 | 00 04 | 1F 20 03 D5 | 45 4F 46 |

You now have succesfully patched out the d2r online check. (I personally call it d2r_offline_fix) and it can be used with Atmosphere by putting it into /atmosphere/exefs_patches/d2r_offline_fix/32153D9896AE0C7C723F04EC1CE20999CAF7ED69.ips

* [Python script to generate D2R patches, usage: place uncompressed D2R as "main" in the same folder then use "python3 d2r_patch.py"](../scripts/d2r_patch.py)

an example of usage of how to use this python script would be as below:

```
hactool -t pfs0 "Diablo II Resurrected[0100726014352800][US][v655360].nsp" --outdir temp
hactool -t nca temp/LargestNcaInTheFolder.nca --titlekey=TitlekeyForD2RUpdate --exefsdir exefs
hactool -t nso0 exefs/main --uncompressed=main

Output:
NSO0:
    Build Id:                       DCEDBABB85CB423777F7D044BAEC91D5672A5BA8000000000000000000000000
    Sections:
        .text:                      00000000-018cf000
        .rodata:                    018cf000-01d5d000
        .rwdata:                    01d5d000-01e30820
        .bss:                       01e30820-02f45000
Done!
python3 scripts/d2r_patch.py

Output:
d2r build-id: DCEDBABB85CB423777F7D044BAEC91D5672A5BA8
d2r offset and patch at: 1C670800041F2003D5
d2r cheat string: 04000000 001C6608 D503201F
```

- [The IPS patch from the example output](../SigPatches/atmosphere/exefs_patches/d2r_offline_fix/DCEDBABB85CB423777F7D044BAEC91D5672A5BA8.ips)
- [The same patch, but in cheat format from the example output](../cheats/atmosphere/contents/0100726014352000/cheats/DCEDBABB85CB4237.txt)
